<?php if (!defined('APPLICATION')) exit();
/**
*
* # FlaggingNotify #
*
* ### About ###
* This plugin creates annoying persistent notification of flagged posts, to ensure they are dealt with, and can be dismissed within the notification.
*
* ### Sponsor ###
* Special thanks to MCDE for making this happen.
*
*/
// Define the plugin:
$PluginInfo['FlaggingNotify'] = array(
	'Name' => 'FlaggingNotify',
	'Description' => 'This plugin creates annoying persistent notification of flagged posts, to ensure they are dealt with, and can be dismissed within the notification.',
	'Version' => '0.2b',
	'RequiredPlugins' => array('Flagging'=>'>=1.1.0'),
	'Author' => "Paul Thomas",
	'AuthorEmail' => 'dt01pqt_pt@yahoo.com',
);
/*
 * Changelog:
 * v0.2b:Mon Feb 20 08:51:25 GMT 2012
 * - change permission from Garden.Settings.Manage to Plugins.Flagging.Notify
 */

class FlaggingNotifyPlugin extends Gdn_Plugin {
   
	public function Base_BeforeControllerMethod_Handler($Sender) {
		if(!C('Plugins.Flagging.Enabled') || !Gdn::Session()->CheckPermission('Plugins.Flagging.Notify'))
			return;
			
		/**
		 * 	get flags determine if still active, making a list
		 */
		$Flags = Gdn::SQL()
			->Select('*')
			->From('Flag')
			->Where(
				array(
					'NotifyDismiss'=>0,
					//'DiscussionID >'=>0
				)
			)
			->OrderBy('DateInserted', 'DESC')
			->Get()
			->Result();
		
		$FlagList = array();
		$DiscussionIDs = array();
		$CommentIDs = array();
		
		
		
		foreach($Flags As $Flag){
			
			if(strtolower($Flag->ForeignType)=='comment')
				$CommentIDs[]=$Flag->ForeignID;
			else
				$DiscussionIDs[]=$Flag->ForeignID;
		}
		
		if(!empty($DiscussionIDs))
			$Discussions = Gdn::SQL()
				->Select('*')
				->From('Discussion')
				->WhereIn('DiscussionID',$DiscussionIDs)
				->Get()
				->Result();
		else
			$Discussions=array();
		
		if(!empty($CommentIDs))
			$Comments = (empty($CommentIDs))? array() : Gdn::SQL()
				->Select('*')
				->From('Comment')
				->WhereIn('CommentID',$CommentIDs)
				->Where('DateDeleted',NULL)
				->Get()
				->Result();
		else
			$Comments = array();
		$DiscussionIDs = array();
		$CommentIDs = array();
		foreach($Discussions As $Discussion)
			$DiscussionIDs[]=$Discussion->DiscussionID;
		foreach($Comments As $Comment)
			$CommentIDs[]=$Comment->CommentID;
		foreach($Flags As $Flag){
			if((in_array($Flag->ForeignID,$DiscussionIDs) && strtolower($Flag->ForeignType)=='discussion') 
				|| (strtolower($Flag->ForeignType)=='comment' && in_array($Flag->ForeignID,$CommentIDs))){
			
				$FlagList[$Flag->ForeignURL]=$Flag;
			}
		}
		
		/**
		 * 	With the discussion controller check if request is same as ForeignID and dismiss appropriately
		 */
		
		/*if($Sender->Controller()=='Discussion'){
			$DissmisFlags=array();
			$IsComment = strtolower($Sender->ControllerMethod())=='comment';
			$Args=$Sender->ControllerArguments();
			$ObjectID = !empty($Args) ? $Args[0] : 0;
			if(!$ObjectID)
				return;
			foreach($FlagList As $FlagItem){
				if(($IsComment && $FlagItem->ForeignID==$ObjectID && strtolower($FlagItem->ForeignType)=='comment') ||
				($FlagItem->ForeignID==$ObjectID && strtolower($FlagItem->ForeignType)=='discussion')){
					$DissmisFlags[$FlagItem->ForeignURL]=$FlagItem->ForeignURL;
				}
				
			}
			if(!empty($DissmisFlags))
				Gdn::SQL()->Update('Flag')->Set('NotifyDismiss',1)->WhereIn('ForeignURL',$DissmisFlags)->Put();
		}*/
			
		/**
		 * 	display notifications
		 */
		
		foreach($FlagList As $FlagItem){
			$FlagName = substr($FlagItem->ForeignURL,strpos($FlagItem->ForeignURL,'/',1));
			$Hash = strpos($FlagName,'#');
			if($Hash!==FALSE)
				$FlagName = substr($FlagName,0,$Hash);
			$FlagText='<span class="InformSprite Flag"></span>';
			$FlagText.=Anchor($FlagName,$FlagItem->ForeignURL).' '; 
			$FlagText.=T('FlaggedBy', "Reported by: ").
			'<strong>'.Anchor($FlagItem->InsertName,'profile/'.$FlagItem->InsertUserID.'/'.$FlagItem->InsertName).'</strong> ';
			$FlagText.='<i>"'.$FlagItem->Comment.'"</i> &nbsp;';
			/**
			 * 	Allow to be dismissed from the notification
			 */ 
			$EncodedURL=URL('plugin/flagging/dismiss/'.str_replace('=','-',base64_encode($FlagItem->ForeignURL)),TRUE);
			$FlagText.=Anchor('Dismiss',$EncodedURL,array(
				'onclick'=>'jQuery.get("'.$EncodedURL.'");jQuery(this).parent().remove();return false;',
				'class'=>'Button',
				'style'=>'color:#000;background: #f8f8f8;margin:0;')
			);
			
			//if(!in_array($FlagItem->ForeignURL,$DissmisFlags))
				Gdn::Controller()->InformMessage($FlagText,'HasSprite');
		}
	}
	
    public function Base_BeforeDispatch_Handler($Sender){
        if(C('Plugins.FlaggingNotify.Version')!=$this->PluginInfo['Version'])
            $this->Structure();
    }
   
	public function Structure() {
		$Structure = Gdn::Structure();
		$Structure
		->Table('Flag')
		->Column('NotifyDismiss', 'int(4)', 0)
		->Set();
        //Save Version for hot update

        @SaveToConfig('Plugins.FlaggingNotify.Version', $this->PluginInfo['Version']);
	}

	public function Setup() {
		$this->Structure();
		
	}
   
}
